void plotOrigHisto() {
  pushStyle();
  stroke(0);
  strokeWeight(2);
  for( int i = 0; i < histSize-1; i += 1 ) {
    if( colorHisto ) {
      stroke(255,0,0);
      line( map(i, 0, 255, 0, width), map(srcHistR[i], 0, 1.0, height, 0), map(i+1, 0, 255, 0, width), map(srcHistR[i+1], 0, 1.0, height, 0) );
      stroke(0,255,0);
      line( map(i, 0, 255, 0, width), map(srcHistG[i], 0, 1.0, height, 0), map(i+1, 0, 255, 0, width), map(srcHistG[i+1], 0, 1.0, height, 0) );
      stroke(0,0,255);
      line( map(i, 0, 255, 0, width), map(srcHistB[i], 0, 1.0, height, 0), map(i+1, 0, 255, 0, width), map(srcHistB[i+1], 0, 1.0, height, 0) );
    } else {
      stroke(0);
      line( map(i, 0, 255, 0, width), map(srcHist[i], 0, 1.0, height, 0), map(i+1, 0, 255, 0, width), map(srcHist[i+1], 0, 1.0, height, 0) );
    }
  }
  popStyle();
}

void plotDestHisto() {
  pushStyle();
  strokeWeight(1);
  stroke(0);
  float r, g, b;
  float aP, bP, v;
  /*
  // draw markers equally across height
  for( float i = 0; i <= 1.0; i += 0.025 ) {
    if( colorHisto ) {
      fill(255,0,0);
      r = pow( 1.0 - pow(1.0-i, bParam[0]), aParam[0] );
      ellipse( map(r, 0, 1.0, 0, width), map(i, 0, 1.0, height, 0), 3, 3 );
      fill(0,255,0);
      g = pow( 1.0 - pow(1.0-i, bParam[1]), aParam[1] );
      ellipse( map(g, 0, 1.0, 0, width), map(i, 0, 1.0, height, 0), 3, 3 );
      fill(0,0,255);
      b = pow( 1.0 - pow(1.0-i, bParam[2]), aParam[2] );
      ellipse( map(b, 0, 1.0, 0, width), map(i, 0, 1.0, height, 0), 3, 3 );
    } else {
      aP = (aParam[0]+aParam[1]+aParam[2])/3.0;
      bP = (bParam[0]+bParam[1]+bParam[2])/3.0;
      fill(255);
      v = pow( 1.0 - pow(1.0-i, bP), aP );
      ellipse( map(v, 0, 1.0, 0, width), map(i, 0, 1.0, height, 0), 3, 3 );
    }
  }
  */
  // draw markers equally across width
  for( float i = 0; i <= 1.0; i += 0.025 ) {
    if( colorHisto ) {
      fill(255,0,0);
      r = 1.0 - pow( 1.0 - pow(i,1/aParam[0]), 1/bParam[0]);
      ellipse( map(i, 0, 1.0, 0, width)-3, map(r, 0, 1.0, height, 0), 3, 3 );
      fill(0,255,0);
      g = 1.0 - pow( 1.0 - pow(i,1/aParam[1]), 1/bParam[1]);
      ellipse( map(i, 0, 1.0, 0, width), map(g, 0, 1.0, height, 0), 3, 3 );
      fill(0,0,255);
      b = 1.0 - pow( 1.0 - pow(i,1/aParam[2]), 1/bParam[2]);
      ellipse( map(i, 0, 1.0, 0, width)+3, map(b, 0, 1.0, height, 0), 3, 3 );
    } else {
      aP = (aParam[0]+aParam[1]+aParam[2])/3.0;
      bP = (bParam[0]+bParam[1]+bParam[2])/3.0;
      fill(255);
      v = 1.0 - pow( 1.0 - pow(i,1/aP), 1/bP);
      ellipse( map(i, 0, 1.0, 0, width), map(v, 0, 1.0, height, 0), 3, 3 );
    }
  }
  popStyle();
}

void plotOrigPDF() {
  pushStyle();
  float x1 = 0, y1 = 0, x2 = 0, y2 = 0;
  float s = 0.01;
  if( useLAB ) {
    s = 0.01;
  }
  strokeWeight(2);
  for( int i = 0; i < histSize-1; i += 1 ) {
    x1 = map(i,0,histSize-1,0,width);
    x2 = map(i+1,0,histSize-1,0,width);
    y1 = map((float)(srcPDF[i][0]), 0, s, height, 0);
    y2 = map((float)(srcPDF[i+1][0]), 0, s, height, 0);
    stroke(255,0,0);
    line(x1,y1,x2,y2);
    y1 = map((float)(srcPDF[i][1]), 0, s, height, 0);
    y2 = map((float)(srcPDF[i+1][1]), 0, s, height, 0);
    stroke(0,200,0);
    line(x1,y1,x2,y2);
    y1 = map((float)(srcPDF[i][2]), 0, s, height, 0);
    y2 = map((float)(srcPDF[i+1][2]), 0, s, height, 0);
    stroke(0,0,255);
    line(x1,y1,x2,y2);
  }
  popStyle();
}

void plotDestPDF() {
  pushStyle();
  strokeCap(SQUARE);
  float a = 1.0;
  float b = 1.0;
  float c = 1.0;
  float d = 1.0;
  float x1 = 0, y1 = 0, x2 = 0, y2 = 0;
  strokeWeight(2);
  float pdfMax = 4.0;
  float step = 0.01;
  for( float i = step/2.0; i < 1.0-step; i += step ) {
    x1 = i;
    x2 = i + step*0.67;
    if( colorHisto ) {
      stroke(192, 0, 0);
      a = 1.0/aParam[0];
      b = 1.0/bParam[0];
      if( distro == DISTRO_KUMARA ) {
        y1 = min( a*b*pow(x1,a-1.0)*pow(1-pow(x1,a),b-1.0), 4000 );
        y2 = min( a*b*pow(x2,a-1.0)*pow(1-pow(x2,a),b-1.0), 4000 );
      } else if( distro == DISTRO_GKUMARA4P ) {
        c = 1.0/cParam[0];
        d = dParam[0];
        y1 = min( a*b*c*(d+1)*pow(x1,a-1.0)*pow(1-pow(x1,a),b-1.0)*pow(1-pow(1-pow(x1,a),b),c-1)*pow(1-pow(1-pow(1-pow(x1,a),b),c),d), 4000 );
        y2 = min( a*b*c*(d+1)*pow(x2,a-1.0)*pow(1-pow(x2,a),b-1.0)*pow(1-pow(1-pow(x2,a),b),c-1)*pow(1-pow(1-pow(1-pow(x2,a),b),c),d), 4000 );
      }
      line( map(x1, 0, 1.0, 0, width), map(y1, 0, pdfMax, height, 0), map(x2, 0, 1.0, 0, width), map(y2, 0, pdfMax, height, 0) );
      stroke(0, 192, 0);
      a = 1.0/aParam[1];
      b = 1.0/bParam[1];
      if( distro == DISTRO_KUMARA ) {
        y1 = min( a*b*pow(x1,a-1.0)*pow(1-pow(x1,a),b-1.0), 4000 );
        y2 = min( a*b*pow(x2,a-1.0)*pow(1-pow(x2,a),b-1.0), 4000 );
      } else if( distro == DISTRO_GKUMARA4P ) {
        c = 1.0/cParam[1];
        d = dParam[1];
        y1 = min( a*b*c*(d+1)*pow(x1,a-1.0)*pow(1-pow(x1,a),b-1.0)*pow(1-pow(1-pow(x1,a),b),c-1)*pow(1-pow(1-pow(1-pow(x1,a),b),c),d), 4000 );
        y2 = min( a*b*c*(d+1)*pow(x2,a-1.0)*pow(1-pow(x2,a),b-1.0)*pow(1-pow(1-pow(x2,a),b),c-1)*pow(1-pow(1-pow(1-pow(x2,a),b),c),d), 4000 );
      }
      line( map(x1, 0, 1.0, 0, width), map(y1, 0, pdfMax, height, 0), map(x2, 0, 1.0, 0, width), map(y2, 0, pdfMax, height, 0) );
      stroke(0, 0, 192);
      a = 1.0/aParam[2];
      b = 1.0/bParam[2];
      if( distro == DISTRO_KUMARA ) {
        y1 = min( a*b*pow(x1,a-1.0)*pow(1-pow(x1,a),b-1.0), 4000 );
        y2 = min( a*b*pow(x2,a-1.0)*pow(1-pow(x2,a),b-1.0), 4000 );
      } else if( distro == DISTRO_GKUMARA4P ) {
        c = 1.0/cParam[2];
        d = dParam[2];
        y1 = min( a*b*c*(d+1)*pow(x1,a-1.0)*pow(1-pow(x1,a),b-1.0)*pow(1-pow(1-pow(x1,a),b),c-1)*pow(1-pow(1-pow(1-pow(x1,a),b),c),d), 4000 );
        y2 = min( a*b*c*(d+1)*pow(x2,a-1.0)*pow(1-pow(x2,a),b-1.0)*pow(1-pow(1-pow(x2,a),b),c-1)*pow(1-pow(1-pow(1-pow(x2,a),b),c),d), 4000 );
      }
      line( map(x1, 0, 1.0, 0, width), map(y1, 0, pdfMax, height, 0), map(x2, 0, 1.0, 0, width), map(y2, 0, pdfMax, height, 0) );
    } else { 
      stroke(32);
      a = (1.0/(aParam[0]+aParam[1]+aParam[2]))/3.0;
      b = (1.0/(bParam[0]+bParam[1]+bParam[2]))/3.0;
      y1 = min( a*b*pow(x1,a-1.0)*pow(1-pow(x1,a),b-1.0), 4000 );
      y2 = min( a*b*pow(x2,a-1.0)*pow(1-pow(x2,a),b-1.0), 4000 );
      line( map(x1, 0, 1.0, 0, width), map(y1, 0, pdfMax, height, 0), map(x2, 0, 1.0, 0, width), map(y2, 0, pdfMax, height, 0) );
    }
  }
  popStyle();
}

